// Com.h: interface for the CCom class.
//
//////////////////////////////////////////////////////////////////////

#if !defined _COM_H_
#define _COM_H_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


class CCom  
{
private:

	HANDLE m_hCom;        //Manipulador del port serie.
	OVERLAPPED m_ov;
	DWORD  m_dwBaudRate;  //Velocitat de transmissi(simbos/seg)
	LPCSTR m_lpszPortNum; //String amb el nom del port.
	BYTE   m_byParity;	  //Determina transmissi amb paritat o sense.
	BYTE   m_byStopBits;  //Nmero de bits de parada.
	BYTE   m_byByteSize;  //Longitud del byte de dades.
public:
	CCom();
	virtual ~CCom();
	DWORD WriteData(unsigned char *,DWORD len);
	DWORD ReadData(unsigned char*,DWORD dwMaxWait);
	DWORD CCom::ReadData(unsigned char *pdest);
	BOOL Open();
    void Close();
	DWORD Envio(unsigned char *Tr);
	int LeerTrama(unsigned char *TrRec);
	void Set_Read_Time_Out(DWORD ReadTimeOut);
	void Clean_Input_Buffer();
	unsigned char TTrama[256];	

};

#endif // !defined _COM_H_
