// CVisioPaletDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CVisioPalet.h"
#include "CVisioPaletDlg.h"
#include "string.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCVisioPaletDlg dialog

CCVisioPaletDlg::CCVisioPaletDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCVisioPaletDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCVisioPaletDlg)
	m_Slider_Sat = 0;
	m_szFocus = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCVisioPaletDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCVisioPaletDlg)
	DDX_Control(pDX, IDC_SLIDER_SHARP, m_SliderSharp);
	DDX_Control(pDX, IDC_SLIDER_FOCUS, m_Slider_Focus);
	DDX_Control(pDX, IDC_SLIDER_ZOOM, m_Slider_Zoom);
	DDX_Control(pDX, IDC_SLIDER_BRIG, m_Slider_Brig);
	DDX_Control(pDX, IDC_SLIDER_SATURATION, m_Slider_Saturation);
	DDX_Control(pDX, IDC_SLIDER_HUE, m_Slider_Hue);
	DDX_Control(pDX, IDC_SLIDER_WHITE_BAL_V, m_Slider_WV);
	DDX_Control(pDX, IDC_SLIDER_WHITE_REF, m_Slider_WU);
	DDX_Control(pDX, IDC_PICTURE, m_PictureWin);
	DDX_Slider(pDX, IDC_SLIDER_SATURATION, m_Slider_Sat);
	DDX_Text(pDX, IDC_FOCUS_VALUE, m_szFocus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCVisioPaletDlg, CDialog)
	//{{AFX_MSG_MAP(CCVisioPaletDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_WHITE_REF, OnCustomdrawSliderWhiteRef)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_WHITE_BAL_V, OnCustomdrawSliderWhiteBalV)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_HUE, OnCustomdrawSliderHue)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_SATURATION, OnCustomdrawSliderSaturation)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_BRIG, OnCustomdrawSliderBrig)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_ZOOM, OnCustomdrawSliderZoom)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_FOCUS, OnCustomdrawSliderFocus)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_SHARP, OnCustomdrawSliderSharp)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCVisioPaletDlg message handlers

BOOL CCVisioPaletDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
     
	//Limits slider White Balance U.
	m_Slider_WU.SetRange(MyMil.GetMinWBU(),MyMil.GetMaxWBU());
	//Limits slider White Balance U.
	m_Slider_WV.SetRange(MyMil.GetMinWBV(),MyMil.GetMaxWBV());
	//Limits slider White Balance U.
	m_Slider_Hue.SetRange(MyMil.GetMinHue(),MyMil.GetMaxHue());
	//Limits slider Saturacio.
	m_Slider_Saturation.SetRange(MyMil.GetMinSat(),MyMil.GetMaxSat());
	//Limits slider Brightness.
	m_Slider_Brig.SetRange(MyMil.GetMinBrig(),MyMil.GetMaxBrig());
	//Limits slider Zoom
	m_Slider_Zoom.SetRange(MyMil.GetMinZoom(),MyMil.GetMaxZoom());
	//Limits slider Zoom
	m_Slider_Focus.SetRange(MyMil.GetMinFocus(),MyMil.GetMaxFocus());
	//Limits slider Sharpness
	m_SliderSharp.SetRange(MyMil.GetMinSharp(),MyMil.GetMaxSharp());

	MyMil.SetDefaultsValues();
	m_Slider_WU.SetPos(159);
	m_Slider_WV.SetPos(255);
	m_Slider_Hue.SetPos(198);
	m_Slider_Saturation.SetPos(79);
	m_Slider_Brig.SetPos(40);
	m_Slider_Zoom.SetPos(MyMil.GetMinZoom());
	m_Slider_Focus.SetPos(MyMil.GetMaxFocus());
	char string[10];
	itoa(MyMil.GetMaxFocus(),string,10);
	m_szFocus = string;
	UpdateData(FALSE);
	m_SliderSharp.SetPos(MyMil.GetMaxSharp());



	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCVisioPaletDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCVisioPaletDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCVisioPaletDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCVisioPaletDlg::OnButton1() 
{

	/*
	// TODO: Add your control notification handler code here
	for(int i=0;i< 100;i++){
     MyMil.GetFrame();
	 MyMil.ShowFrame(m_PictureWin.m_hWnd);
	 MyMil.AddImageToArray(i);}
	
		static char BASED_CODE szFilter[] = "Videos (*.avi)|*.avi|All Files (*.*)|*.*||";  
		// Crea un Open dialog
		CFileDialog fileDlg (FALSE, _T("shv"), _T("*.avi"),NULL , szFilter);
		// Mostra el file dialog. Quan es prem OK, fileDlg.DoModal() retorna IDOK.
		if( fileDlg.DoModal ()==IDOK )
		{
			CString fileName = fileDlg.GetFileName();
			char Name[200];
			strcpy(Name,fileName);
			MyMil.CreateAvi(Name,i+1);
		}  
	
	*/
	

	unsigned char Buffer[10];
	int NumBytesRead;
	bool fi = false;
	bool Guardafitxer = false;
	int NumFramesGrab = 0;
	//Crrem l'objecte per controlar el port serie.Per defecte es el port COM1.
	pComSerie = new CCom;
	//Obrim el port.
	pComSerie->Open();
	do{
		NumBytesRead = pComSerie->LeerTrama(Buffer);
		if(NumBytesRead != 2){
			AfxMessageBox("Error: No s'han llegit 2 Bytes ");
			fi = true;
		}
		else{
			if(Buffer[0] == 0x01){ //Adquirir nou frame;
				MyMil.GetFrame();
				MyMil.ShowFrame(m_PictureWin.m_hWnd);
				MyMil.AddImageToArray(NumFramesGrab);
				NumFramesGrab++;
				if(NumFramesGrab == MyMil.GetMaxNumFrames()){
					fi = true;
					Guardafitxer=true;
				}
			}
			if(Buffer[0] == 0x02){
				fi = true;
				Guardafitxer = true;
			}
	
		}
	}while(fi == false);
	char f[20];
	sprintf(f,"Num frames:%d",NumFramesGrab);
	AfxMessageBox(f);

	if(Guardafitxer == true){
		static char BASED_CODE szFilter[] = "Videos (*.avi)|*.avi|All Files (*.*)|*.*||";  
		// Crea un Open dialog
		CFileDialog fileDlg (FALSE, _T("shv"), _T("*.avi"),NULL , szFilter);
		// Mostra el file dialog. Quan es prem OK, fileDlg.DoModal() retorna IDOK.
		if( fileDlg.DoModal ()==IDOK )
		{
			CString fileName = fileDlg.GetFileName();
			char Name[200];
			strcpy(Name,fileName);
			MyMil.CreateAvi(Name,NumFramesGrab);
		}  
	}

  delete pComSerie;
	
}

void CCVisioPaletDlg::OnCustomdrawSliderWhiteRef(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlWhiteBalanceU(m_Slider_WU.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;
}


void CCVisioPaletDlg::OnCustomdrawSliderWhiteBalV(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlWhiteBalanceV(m_Slider_WV.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;
	*pResult = 0;
}


void CCVisioPaletDlg::OnCustomdrawSliderHue(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlHue(m_Slider_Hue.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;

}

void CCVisioPaletDlg::OnCustomdrawSliderSaturation(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlSat(m_Slider_Saturation.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;		
}




void CCVisioPaletDlg::OnCustomdrawSliderBrig(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
    MyMil.ControlBrig(m_Slider_Brig.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;		

}

void CCVisioPaletDlg::OnCustomdrawSliderZoom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlZoom(m_Slider_Zoom.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	
	*pResult = 0;
}

void CCVisioPaletDlg::OnCustomdrawSliderFocus(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlFocus(m_Slider_Focus.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);	

	char string[10];
	itoa(m_Slider_Focus.GetPos(),string,10);
	m_szFocus = string;
	UpdateData(FALSE);


	*pResult = 0;
}

void CCVisioPaletDlg::OnCustomdrawSliderSharp(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	MyMil.ControlSharp(m_SliderSharp.GetPos());
	MyMil.GetFrame();
	MyMil.ShowFrame(m_PictureWin.m_hWnd);
	*pResult = 0;
}

void CCVisioPaletDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	int nframes;
	int framerate;
	static char BASED_CODE szFilter[] = "Videos (*.avi)|*.avi|All Files (*.*)|*.*||";  
		// Crea un Open dialog
		CFileDialog fileDlg (TRUE, _T("shv"), _T("*.avi"),NULL , szFilter);
		// Mostra el file dialog. Quan es prem OK, fileDlg.DoModal() retorna IDOK.
		if( fileDlg.DoModal ()==IDOK )
		{
			CString fileName = fileDlg.GetFileName();
			char Name[200];
			strcpy(Name,fileName);

		  MyMil.LoadFramesFromFile(Name,&nframes,&framerate);
		  MyMil.ShowVideo(m_PictureWin.m_hWnd,nframes,framerate);
		}
}

			
			


		
