// MilAplication.h: interface for the CMilAplication class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_)
#define AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "mil.h"

#define NB_GRAB 10
#define Q_FACTOR      50

class CMilAplication  
{

public:
	int m_nSizeX;              //Tamany de la imatge `redimensionada al tamany de display. 
	int m_nSizeY;			   //Tamany de la imatge `redimensionada al tamany de display. 
	int m_nSource_SizeX;       //Tamany X de la imatge original a pintar per pantalla.         
	int m_nSource_SizeY;       //Tamany Y de la imatge original a pintar per pantalla.

   MIL_ID   MilApplication  ;
   MIL_ID   MilSystem       ;
   MIL_ID   MilDigitizer    ;
   MIL_ID   MilDisplay      ;
   MIL_ID   MilImage[NB_GRAB];
   MIL_ID   MilImageDisp    ;
  
   double Time;            
   double TimeWait;        
   double TotalReplay;     
   double ImageScale;      
   long   n;               
   long   ExtendedAttrib;  
   long   NbFrames;        
   long   Selection;       
   long   LicenseModules;  


	
    CMilAplication();


	//void VisualitzarImatge(HWND finestra,MIL_ID Imatge,MIL_ID ImDisp);
	void GetImageFromFile(char *path,char *name);
	virtual ~CMilAplication();

};

#endif // !defined(AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_)
