// MilAplication.h: interface for the CMilAplication class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_)
#define AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "mil.h"

#define NB_GRAB 200
#define Q_FACTOR      50

class CMilAplication  
{

public:
	int m_nSizeX;              //Tamany de la imatge `redimensionada al tamany de display. 
	int m_nSizeY;			   //Tamany de la imatge `redimensionada al tamany de display. 
	int m_nSource_SizeX;       //Tamany X de la imatge original a pintar per pantalla.         
	int m_nSource_SizeY;       //Tamany Y de la imatge original a pintar per pantalla.

	int m_MaxGrabNum;


	long Hue_min,Hue_max,Hue;
	long Sat_min,Sat_max,Sat;
	long Brig_min,Brig_max,Brig;
	long WBU_max,WBU_min,WBU;
	long WBV_max,WBV_min,WBV;
	long Zoom_max,Zoom_min,Zoom;
	long Focus_max,Focus_min,Focus;
	long Sharp_max,Sharp_min,Sharp;


   MIL_ID   MilApplication  ;
   MIL_ID   MilSystem       ;
   MIL_ID   MilDigitizer    ;
   MIL_ID   MilDisplay      ;
   MIL_ID   MilImage[NB_GRAB];
   MIL_ID   MilImageAux   ;
  
   double Time;            
   double TimeWait;        
   double TotalReplay;     
   double ImageScale;      
   long   n;               
   long   ExtendedAttrib;  
   long   NbFrames;        
   long   Selection;       
   long   LicenseModules;  


	
    CMilAplication();
    void ShowFrame(HWND finestra);
	void GetFrame();
	void AddImageToArray(int i);
	void CreateAvi(char *filename,int numframes);
void LoadFramesFromFile(char *Name,int *nframes,int *framerate);
void ShowVideo(HWND finestra,int nframes,int framerate);
   void  AskForLimits();

	long GetMinWBU();
	long GetMaxWBU();
	void ControlWhiteBalanceU(long value);

	long GetMinWBV();
	long GetMaxWBV();
	void ControlWhiteBalanceV(long value);

	long GetMinHue();
	long GetMaxHue();
	void ControlHue(long value);

	long GetMinSat();
    long GetMaxSat();
	void ControlSat(long value);

	//Funcions Brig
	long GetMinBrig();
	long GetMaxBrig();
	void ControlBrig(long value);

	long GetMinZoom();
	long GetMaxZoom();
	void ControlZoom(long value);

	long GetMinFocus();
	long GetMaxFocus();
	void ControlFocus(long value);


	long GetMinSharp();
	long GetMaxSharp();
	void ControlSharp(long value);



	void SetDefaultsValues();

	int GetMaxNumFrames();



	//void VisualitzarImatge(HWND finestra,MIL_ID Imatge,MIL_ID ImDisp);
	void GetImageFromFile(char *path,char *name);
	virtual ~CMilAplication();

};

#endif // !defined(AFX_MILAPLICATION_H__DF54E8C2_4774_11D7_AA2D_0004769F9FC4__INCLUDED_)
