// VisioPaletDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisioPalet.h"
#include "VisioPaletDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
	//CAboutDlg();
public:
CAboutDlg();
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisioPaletDlg dialog

CVisioPaletDlg::CVisioPaletDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVisioPaletDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVisioPaletDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVisioPaletDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVisioPaletDlg)
	DDX_Control(pDX, IDC_IMAGE, m_ImWin);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVisioPaletDlg, CDialog)
	//{{AFX_MSG_MAP(CVisioPaletDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisioPaletDlg message handlers

BOOL CVisioPaletDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	CMenu *pMainMenu = new CMenu;               //Crrem un Objecte per el menur principal.
	ASSERT(pMainMenu->LoadMenu(IDR_MAIN_MENU)); //Carreguem el recurs MAIN_MENU.
	SetMenu(pMainMenu);                         //Apliquem el menu. 
	CRect Rect;
	m_ImWin.GetWindowRect(&Rect);
	Pic.m_nSizeX = (Rect.right - Rect.left);
	Pic.m_nSizeY = (Rect.bottom - Rect.top);
	//Guardem espai per enmagatzemar una imatge que serveixi de display.
	MbufAllocColor(Pic.MilSystem,3,Pic.m_nSizeX,Pic.m_nSizeY,8+M_UNSIGNED,M_IMAGE+M_PROC+M_DISP,&Pic.MilImatge_Disp);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVisioPaletDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVisioPaletDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVisioPaletDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVisioPaletDlg::OnButton1() 
{
	unsigned char Trama[10];
	MyCom = new CCom; //Construim objecte de comunicacions.
	MyCom->Open();
	MyCom->LeerTrama(Trama);

	
	if(Trama[0]==unsigned char('H')){
	// TODO: Add your control notification handler code here
	//Pic.GetImageFromFile("quadrat1.bmp"," ");
	//Pic.VisualitzarImatge(this->m_ImWin.m_hWnd,
	//MdispSelectWindow(Pic.MilDisplay,Pic.MilImatge_Disp,m_ImWin.m_hWnd);
	 AfxMessageBox("Ha arribat una H");
	}
	if(Trama[0]==unsigned char('M')) AfxMessageBox("Ha arribat una M");
	delete MyCom; //Destruim objecte.	
	
}
